﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Forms;
using LiveCharts;
using LiveCharts.Wpf;

namespace GraficarEcuacion2
{
    public partial class Form1 : Form
    {

        // Declaración global de miGrafica
        Graficador miGrafica = new Graficador("Mes", "Ventas");
        public Form1()
        {
            InitializeComponent();
        }

        private void GenerarAleatorios()
        {
            Random aleatorio = new Random();

            string[] arregloMeses = { "Ene", "Feb", "Mar", "Abr", "May", "Jun", "Jul", "Ago", "Sep", "Oct", "Nov", "Dic" };

            dgVentas.Rows.Clear();

            for (int i = 0; i < int.Parse(txtCantidad.Text); i++)
            {
                string strMes= arregloMeses[aleatorio.Next(1,12)]+aleatorio.Next(2000,DateTime.Now.Year+1).ToString();
                dgVentas.Rows.Add(strMes, aleatorio.NextDouble() * 1500);
            }
        }
        private void Form1_Load(object sender, EventArgs e)
        {
            txtCantidad.Text = "50";
            txtCantidad.Focus();
            // No permitir agregar ni eliminar renglones
            dgVentas.AllowUserToAddRows = false;
            dgVentas.AllowUserToDeleteRows = false;

            // Autoajustar el ancho de las columnas
            dgVentas.AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.Fill;

            // Seleccionar un renglón completo al hacer click
            dgVentas.SelectionMode = DataGridViewSelectionMode.FullRowSelect;

            // No se permite seleccionar varios renglones
            dgVentas.MultiSelect = false;

            dgVentas.Columns.Add("Mes", "Mes");
            dgVentas.Columns.Add("Cantidad", "Cantidad");
            dgVentas.Columns["Cantidad"].DefaultCellStyle.Format = "C";
        }


        private void btnGraficar_Click(object sender, EventArgs e)
        {
            GenerarAleatorios();  // Genera datos aleatorios y los almacena en el dataGridView

            miGrafica = new Graficador("Mes","Ventas");  // Crea un objeto de una gráfica
            Punto nuevoPunto;  // Declaración de un objeto de un punto de la gráfica

            // Recorrer el dataGridView para obtener los puntos de la gráfica
            for (int i = 0; i < dgVentas.Rows.Count; i++)
            {
                string strEtiqueta= dgVentas[0, i].Value.ToString();
                double dblValor = double.Parse( dgVentas[1,i].Value.ToString());

                nuevoPunto = new Punto(strEtiqueta, dblValor);  // Crea un objeto de un punto de la gráfica
                miGrafica.InsertarPunto(nuevoPunto);  // Inserta el nuevo punto en la lista de puntos
            }

            CrearNuevaFormaConGrafica();
        }

        private void CrearNuevaFormaConGrafica()
        {
            Form frmNuevaVentana = new Form();  // Creación de una nueva forma para dibujar la gráfica

            frmNuevaVentana.AutoScroll = true;  // Activa el modo AutoScroll
            frmNuevaVentana.Text = "G R Á F I C A";  // Texto de la nueva forma
            frmNuevaVentana.WindowState = FormWindowState.Maximized;  // Maximiza la ventana
            frmNuevaVentana.AutoSize = true;
            frmNuevaVentana.Show();  // Muestra la nueva forma

            LiveCharts.WinForms.CartesianChart miCartesianChart = new LiveCharts.WinForms.CartesianChart();
            miCartesianChart.Width = frmNuevaVentana.Width - 50;
            miCartesianChart.Height = frmNuevaVentana.Height - 50;
            miCartesianChart.Parent = frmNuevaVentana;
            miCartesianChart.BackColor = Color.White;
            
            miGrafica.Graficar(miCartesianChart);  // Genera la gráfica
            miCartesianChart.Show();  // Muestra la gráfica
        }

    }
}
